/**
 *
 * Thu Mar 12 00:00:00 1998 CanvasPanel.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
// Canvas panel shows a Canvas in an attractive way
import java.util.Vector;
import java.awt.*;

public class CanvasPanel extends Panel
{
	GridBagConstraints gbc = new GridBagConstraints();
	GridBagLayout gbl = new GridBagLayout();
	
	private Class areaProto, labelProto, centerProto;
	public Component center, tl, tm, tr, bl, bm, br;	
	private Vector list = new Vector();
	
	final static float [] wx = { 3, 1,1,1, 1,1,1 };
	final static float [] wy = { 7, 0,0,0, 0,0,0 };
	final static int [] gx = { 0, 0,1,2, 0,1,2 };
	final static int [] gy = { 1, 0,0,0, 2,2,2 };
	final static int [] gw = { 3, 1,1,1, 1,1,1 };
	final static int [] gh = { 1, 1,1,1, 1,1,1 };
                    final static int [] f = { GridBagConstraints.BOTH, 
			     GridBagConstraints.HORIZONTAL, 
			     GridBagConstraints.HORIZONTAL, 
			     GridBagConstraints.HORIZONTAL, 
			     GridBagConstraints.HORIZONTAL, 
			     GridBagConstraints.HORIZONTAL, 
			     GridBagConstraints.HORIZONTAL };
	
	
 	private void getGBC( int i )
	{
		gbc.fill = f[i];
		gbc.weightx = wx[i];
		gbc.weighty = wy[i];
		gbc.gridx = gx[i];
		gbc.gridy = gy[i];
		gbc.gridwidth = gw[i];
		gbc.gridheight = gh[i];
	}
	
	private void build() throws InstantiationException, IllegalAccessException
	{
		center = (Component)centerProto.newInstance(); list.addElement(center);
		tl = (Component)labelProto.newInstance(); list.addElement(tl);
		tm = (Component)labelProto.newInstance(); list.addElement(tm);
		if (tm instanceof Label) ((Label)tm).setAlignment( Label.CENTER );
		tr = (Component)areaProto.newInstance(); list.addElement(tr);
		if (tr instanceof Label) ((Label)tr).setAlignment( Label.RIGHT );
		bl = (Component)areaProto.newInstance(); list.addElement(bl);
		bm = (Component)labelProto.newInstance(); list.addElement(bm);
		if (bm instanceof Label) ((Label)bm).setAlignment( Label.CENTER );
		br = (Component)labelProto.newInstance(); list.addElement(br);
		if (br instanceof Label) ((Label)br).setAlignment( Label.RIGHT );
		for( int i=0; i<list.size(); i++ ) {
			getGBC(i);		
			Component c = (Component)list.elementAt(i);
			gbl.setConstraints( c, gbc );
			add( c );		
		}		
	}
	
	CanvasPanel( Class aP, Class lP, Class cP )
	{ 
		labelProto=lP; 
		areaProto=aP;		
		centerProto = cP;
		setLayout( gbl );
		try { 
			build();
		  } catch( Exception e ) { 
		  	System.out.println("Exception in CanvasPanel build: "+e.toString() );
		}
	}


}
