/**
 *
 * Fri Apr 24 01:00:00 1998 ColorsFrame.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.util.*;

public class ColorsFrame extends Frame{
  public Label Pgcoll = new Label("Grid Color",Label.RIGHT),
    Pbcoll = new Label("Background",Label.RIGHT),
    Prcoll = new Label("Ruler Background",Label.RIGHT);
  public Choice Pgcolor = new Choice(),
    Pbcolor = new Choice(),
    Prcolor = new Choice();
  public Button Pok = new Button("OK"),
    Papply = new Button("Apply");
  private JavaPlot host;
  public ColorsFrame(JavaPlot _host){
    super("Canvas Colors");
    host = _host;
    buildPrefs();
  }
  public void open(){
    setVisible(true);
  }
  public synchronized boolean action(Event e, Object w){
    Object chk = e.target;
    if (chk == Papply)
      host.gatherPrefs();
    if (chk == Pok){
      host.gatherPrefs();
      setVisible(false);
    }
    return true;
  }      
  private void buildPrefs(){
      Pgcolor.addItem("Black");
      Pgcolor.addItem("DkGray");
      Pgcolor.addItem("Gray");
      Pgcolor.addItem("LtGray");
      Pgcolor.addItem("White");
      Pgcolor.select("Black");
      Pbcolor.addItem("Black");
      Pbcolor.addItem("DkGray");
      Pbcolor.addItem("Gray");
      Pbcolor.addItem("LtGray");
      Pbcolor.addItem("White");
      Pbcolor.select("LtGray");
      Prcolor.addItem("Black");
      Prcolor.addItem("DkGray");
      Prcolor.addItem("Gray");
      Prcolor.addItem("LtGray");
      Prcolor.addItem("White");
      Prcolor.select("LtGray");
      setLayout(new GridLayout(3,2));
      add(Pgcoll);
      add(Pgcolor);
      add(Pbcoll);
      add(Pbcolor);
      //add(Prcoll);
      //add(Prcolor);
      add(Papply);
      add(Pok);
      resize(300,125);
      validate();
  }
}
