/**
 *
 * Tue Mar 10 00:00:00 1998 CursorSource.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.util.Observable;

class CursorSource extends DataSource
/** this source returns data representing mouse coordinates, as 
    updated by SetPosition. It also keeps track of the extents of mouse
    movement (probably useful for zoom boxes, and easy to do) using
    ResetExtents */
{
	double [] cache = new double[2];
	static int[] dims = { 2 };
	static int button = 0;
	boolean notfirst=false;
	int xn=0,xx=0,yn=0,yx=0;
	
	public void SetPosition( int x, int y, int b)
	{ button = b; cache[0] = (double)x; cache[1] = (double)y; 
	  if (notfirst) {
	    if (x<xn) xn=x;
	    else if (x>xx) xx=x;
            if (y<yn) yn=x;
            else if (y>yx) yx=x;
          } else { 
            yn = y; yx =y;
            xn = x; xx = x;
	    notfirst=true;
          }
          setChanged(); notifyObservers(); 
	}
	public int getButton()
	  { return button; }

	public double[] getData()
	{ return cache; }
	
	public int[] getDimensions()
	{ return dims; }
	
	public void ResetExtents()
	{ notfirst=false; }

	public double[] getExtents()
	{
		if (notfirst==false){
		  double [] chk = {0,1,0,1};
		  return chk; // nothing to say
		}

		double[] r = new double[4];
		r[0] = (double)xn;
		r[1] = (double)xx;
		r[2] = (double)yn;
		r[3] = (double)yx;
		return r;
	}
}
	



