/**
 *
 * Fri Feb 25 12:49:54 2000 DataDescSource.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

import java.util.Observable;

public abstract class DataDescSource extends Observable
{
	public final static String ShortName = "shortname";
	public final static String Label = "label";
	public final static String Units = "units";
	public final static String LongName = "longname";
	public final static String Precision = "precision";
	public final static String Format = "format";
	
	public final static String formatHHMMSS = "HHMMSS";
	public final static String formatYYMMDD = "YYMMDD";
	public final static String formatHours = "hours";
	
	public abstract String getDimensionString( int dim, final String type );
	public abstract String[] getDimensionStrings( final String type );
	
	public abstract DataSource owner(); // may be null
}

