/**
 *
 * Fri Mar 06 00:00:00 1998 DataDialog.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;

public class DataDialog extends Frame implements Runnable
{
  private Button OK = new Button("OK");
  private Checkbox units = new Checkbox("Have Units");
  private TextField filename= new TextField("http://lidar.ssec.wisc.edu/pub/"),
    dataline = new TextField("16",3), 
    labelline = new TextField("13",3), 
    comment = new TextField("",1);
  private Label filen = new Label("URL:", Label.RIGHT),
    datal = new Label("Data begins on line:", Label.RIGHT),
    labell = new Label("Labels are on line:", Label.RIGHT),
    comm = new Label("Comment Char:", Label.RIGHT);
  private boolean made = false;// done = false;
  private GridBagLayout gridbag = new GridBagLayout();
  private GridBagConstraints c = new GridBagConstraints();
  //private Thread thd = null;
  public synchronized void open(){
    new Thread(this).start();
    try{
      wait();
      } catch (InterruptedException e){
      System.out.println("Interrupted.");
    }
  }
  public void run(){
    dialon(true);
  }
  public synchronized void close(){
    dialon(false);
    notifyAll();
  }
  private void dialon(boolean s){
    if (! made)
      make();
    setVisible(s);
  }
  private void make(){
    setTitle("JIPC File Dialog");
    units.setState(true);
    resize(350,150);
    setResizable(false);
    setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 0;
    c.gridwidth = 1;
    gridbag.setConstraints(filen, c);
    add(filen);    
    c.weightx = 1;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(filename,c);
    add(filename);
    c.fill = GridBagConstraints.BOTH;
    c.gridwidth = 1;

    c.weightx = 2;
    gridbag.setConstraints(datal, c);
    add(datal);
    c.weightx = 1;
     gridbag.setConstraints(dataline,c);
    add(dataline);
    c.weightx = 2;
    c.gridwidth = GridBagConstraints.RELATIVE;
     gridbag.setConstraints(comm, c);
    add(comm);
    c.weightx = 1;
     c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(comment,c);
    add(comment);

    c.weightx = 0;
    c.gridwidth = 1;
     gridbag.setConstraints(labell, c);
    add(labell);
    gridbag.setConstraints(labelline,c);
    add(labelline);
    c.gridwidth = GridBagConstraints.RELATIVE;
     gridbag.setConstraints(units, c);
    add(units);
     c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(OK,c);
    add(OK);
    //filename.setText("file:/prism/home/jpgarcia/JIPC/test.dat");
    made = true;
  }

  public boolean action(Event e, Object w){
    Object chk = e.target;
    System.out.println("Dialog's action");
    //if (chk== OK){
      close();
      return true;
      //}
      //return false;
  }

  public String getFile(){return filename.getText();}
  public int getData(){return (new Integer(dataline.getText()).intValue());}
  public int getLabel(){return (new Integer(labelline.getText()).intValue());}
  public boolean getUnits(){return units.getState();}
  public char getComment(){return (comment.getText().toCharArray()[0]);}
}
