/**
 *
 * Fri Feb 25 12:49:54 2000 DataFilter.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

import java.util.Observable;
import java.util.Observer;

public abstract class DataFilter extends DataSource implements Observer
{
	protected DataSource in=null;
	public void SetInput( DataSource _in )
	{ if (in!=null) in.deleteObserver(this);
	  in = _in; 
	  if (in!=null) {
	     setCaching(in.cacheEnabled()); 
	     in.addObserver(this);
	  }
	  setChanged(); notifyObservers(); 
	}

	public double[] getData() 
	{ if (in!=null) return in.getData();  return null; }
	public double[] getExtents()
	{ if (in!=null) return in.getExtents(); return null; }
	public int[] getDimensions()
	{ if (in!=null) return in.getDimensions(); return null; }
		
	public abstract void update( Observable o, Object arg );
}

