/**
 *
 * Thu Mar 19 00:00:00 1998 DataRenderer.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observable;
import java.awt.Graphics;
import java.awt.Color;

public abstract class DataRenderer extends DataFilter implements Runnable, Cloneable
{
  public boolean ThreadPaint = true;
  private Graphics gt = null;
  private Thread self = null;
  private DataRenderer loop = this;
  public final  void paint( Graphics g ){
    //Cancel();
    try{
      DataRenderer newdr = (DataRenderer)(this.clone());
      newdr.gt = g.create();
      self = new Thread(newdr);
    } catch(CloneNotSupportedException cnse){
      System.out.println("DBG: Whoops.  Can't clone this.");
      gt = g.create();
      self = new Thread(this);
    }
    if (ThreadPaint){
      self.setPriority(3);
      self.start();
      System.gc();
    }else
      self.run();
    }
 
  public final void run(){
    //    loop.gt = gt;
    //System.out.println("DBG: "+gt.toString());
    try{
      loop.gt = gt;
      //System.out.println("DBG: "+gt.toString());
      draw(gt);
    }catch (Exception npe){
      //System.out.println("DBG: Exception thrown.  "+loop.toString() +" Cancelled.");
    }
  }
  public void Cancel(){
    try{
      //System.out.println("DBG: "+gt.toString() + " disposed");
      gt.dispose(); 
    }catch(NullPointerException npe){}
    //System.out.println("DBG: " + loop.toString() + " cancel attempt");
  }
  public abstract void draw(Graphics g);
  //public abstract Color color();
}

