/**
 *
 * Mon Apr 20 01:00:00 1998 DocumentFrame.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.net.URL;
import java.io.*;

public class DocumentFrame extends Frame{
  Button ok = new Button("OK");
  TextArea ta = new TextArea(25,60);
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  URL file;
  BufferedReader buff;

  public DocumentFrame(String title, String earl){  
    super(title);
    //ta.setCursor(Frame.DEFAULT_CURSOR);
    setLayout(gbl);
    //add(new Label("no doumentation yet."));
    gbc.fill=GridBagConstraints.BOTH;
    gbc.weightx=1;
    gbc.weighty=1;
    gbc.gridwidth=3;
    gbc.gridheight=1;
    gbc.gridx=0;
    gbc.gridy=0;
    gbl.setConstraints(ta,gbc);
    add(ta);
    gbc.weightx=1;
    gbc.weighty=0;
    gbc.gridwidth=1;
    gbc.gridheight=1;
    gbc.gridx=1;
    gbc.gridy=1;
    gbl.setConstraints(ok,gbc);
    try{
      file = new URL(earl);//"http://lidar.ssec.wisc.edu/jipc/javaplot.doc");
      //file = new URL("file:/home/jpgarcia/JIPC/javaplot.doc");
      buff = new BufferedReader(new InputStreamReader(file.openStream()));
      String hold;
      while((hold=buff.readLine()) != null){
	//System.out.println("^"+hold+"^");
	ta.appendText(hold);
	ta.appendText("\n");
      }
    } catch(Exception exc){
      
    }
    ta.setEditable(false);
    add(ok);
    Panel p=new Panel(), q= new Panel();
    gbc.gridx=0;
    gbl.setConstraints(p,gbc);
    add(p);
    gbc.gridx=2;
    gbl.setConstraints(q,gbc);
    add(q);
    validate();
    resize(550,600);
  }
  public synchronized boolean action(Event e, Object w){
    if (e.target == ok)
      setVisible(false);
    return true;
  }
}
class IntroFrame extends Frame{
  Button ok = new Button("OK");
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  private void set(Label in, int loc){
    gbc.gridy=loc;
    gbl.setConstraints(in,gbc);
    add(in);
  }
  public IntroFrame(){  
    super("About This Applet");
    setLayout( gbl );		
    gbc.fill=GridBagConstraints.BOTH;
    gbc.weightx=3;
    gbc.weighty=1;
    gbc.gridwidth=3;
    gbc.gridheight=1;
    gbc.gridx=0;
    ok.setBackground(Color.yellow);
    set(new Label("Java-Plot 0.50b", Label.CENTER),0);
    set(new Label("using JIPC ('Gypsy')", Label.CENTER),1);
    set(new Label("(Java Interactive Plotting Classes)", Label.CENTER),2);
    set(new Label("Core coding by Raymond K. Garcia", Label.CENTER),4);
    set(new Label("Applet development by Joseph P. Garcia", Label.CENTER),3);
    set(new Label("Space Science and Engineering Center", Label.CENTER),5);
    set(new Label("University of Wisconsin - Madison", Label.CENTER),6);
    set(new Label("(C) Copyright 1998 UW SSEC", Label.CENTER),7);
    set(new Label("E-Mail: jpgarcia@execpc.com", Label.CENTER),8);
    Panel p=new Panel(), q= new Panel();
    gbc.gridwidth=1;
    gbc.gridheight=1;
    gbc.weightx=1;
    gbc.gridx=0;
    gbc.gridy=9;
    gbl.setConstraints(p,gbc);
    add(p);
    gbc.gridx=1;
    gbl.setConstraints(ok,gbc);
    add(ok);
    gbc.gridx=2;
    gbl.setConstraints(q,gbc);
    add(q);
    validate();
    resize(300,300);
  }
  public synchronized boolean action(Event e, Object w){
    if (e.target == ok)
      setVisible(false);
    return true;
  }
}
