/**
 *
 * Fri Feb 25 12:49:55 2000 ExtentsStack.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Vector;
import java.util.Observable;
import java.util.Observer;

public class ExtentsStack extends DataFilter
/** every time the input changes, push its new extents onto a stack */
{
	private Vector stack = new Vector();
	private double[] extents = null;

	public double[] getData() 
	{  return null; }
	public double[] getExtents()
	{ if (extents!=null) return extents; return null; }
	public int[] getDimensions()
	{ return null; }
		
	public synchronized void Pop()
	{
		int n = stack.size();
		if (n==0) return;
		n--;
		Object o = stack.elementAt( n );
		stack.removeElementAt( n );
		extents = (double[])o;
		setChanged(); notifyObservers();
	}	
		
	public synchronized void Flush()
	{
		stack = new Vector();
	}
		
	public synchronized void update( Observable o, Object arg )
	{
		if (in==null) return;
		double[] a = in.getExtents();
		if (o==null) return;
		if (extents!=null) stack.addElement( extents );
		extents = a;
		setChanged(); notifyObservers();
	}
}

