/*
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
/*
 * 1.0 code.
 */

import java.awt.*;
import java.util.*;
import java.applet.Applet;
/**
  * This class is altered from Sun's original AppletButton.  I made it
  * specific to the graphing class i wrote inorder to pass parameters
  * from the HTML.  Please honor Sun's copyright and licensing
  */
public class JIPCButton extends Applet implements Runnable {
    int frameNumber = 1;
    String windowClass;
    String buttonText;
    String windowTitle;
    int requestedWidth = 0;
    int requestedHeight = 0;
    Button button;
    Thread windowThread;
    Label label;
    boolean pleaseCreate = false;
  /**
    * applet initialization
    */
    public void init() {
        buttonText = getParameter("BUTTONTEXT");
        if (buttonText == null) {
            buttonText = getParameter("URL");
        }

        windowTitle = getParameter("WINDOWTITLE");
        if (windowTitle == null) {
            windowTitle = getParameter("URL");
        }

        String windowWidthString = getParameter("WINDOWWIDTH");
        if (windowWidthString != null) {
            try {
                requestedWidth = Integer.parseInt(windowWidthString);
            } catch (NumberFormatException e) {
                //Use default width.
            }
        }
 
        String windowHeightString = getParameter("WINDOWHEIGHT");
        if (windowHeightString != null) {
            try {
                requestedHeight = Integer.parseInt(windowHeightString);
            } catch (NumberFormatException e) {
                //Use default height.
            }
        }
 
        setLayout(new BorderLayout());
	//setBackground(Color.white);
        add("West",button = new Button(buttonText));
	button.setBackground(Color.magenta);
        button.setFont(new Font("Times New Roman", Font.PLAIN, 12));

        add("Center",label = new Label("", Label.LEFT));
	label.setFont(new Font("Charter", Font.PLAIN, 10));
    }
  /**
    * applet program
    */
    public synchronized void start() {
        if (windowThread == null) {
            windowThread = new Thread(this, getParameter("URL"));
            windowThread.start();
        }
    }
  /**
    * threaded program
    */
    public synchronized void run() {
        Class windowClassObject = null;
        Class tmp = null;
        String name = null;
        
        // Make sure the window class exists and is really a Frame.
        // This has the added benefit of pre-loading the class,
        // which makes it much quicker for the first window to come up.
	if (getParameter("URL") ==null)
	  disable();
	
	//Everything's OK. Wait until we're asked to create a window.
	while (windowThread != null) {
	  while (pleaseCreate == false) {
	    try {
	      wait();
	    } catch (InterruptedException e) {
	    }
	  }
	  
	  //We've been asked to bring up a window.
	  //System.out.println("DBG: param YAXIS = " + getParameter("YAXIS"));
	  pleaseCreate = false;
	  JavaPlot window = new JavaPlot(getParameter("URL"),getParameter("DATA"), getParameter("LABEL"), getParameter("UNITS"), getParameter("YAXIS"));

	  window.pack();
	  if ((requestedWidth > 0) | (requestedHeight > 0)) 
	    window.resize(Math.max(requestedWidth,window.size().width),
		       Math.max(requestedHeight,window.size().height));
	  else
	    window.resize(Math.max(requestedWidth,750),
		       Math.max(requestedHeight,600));
	    //}
	  
	  if (frameNumber == 1) {
	    window.setTitle(windowTitle);
	  } else {
	    window.setTitle(windowTitle + ": " + frameNumber);
	  }
	  frameNumber++;
	  
	  //Set the window's size.
	  //window.pack();
	  window.show();
	  label.setText("");
	  button.enable();
	}
    }
  /**
    * action handling
    */          
    public synchronized boolean action(Event event, Object what) {
        if (event.target instanceof Button) {
            //signal the window thread to build a window
	  button.disable();
	  label.setText("Loading...");
	  pleaseCreate = true;
	  notify();
        } 
        return true;
    }
}
