/**
 *
 * Thu Apr 30 01:00:00 1998 JavaPlot.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;
import java.lang.Integer;

public class JavaPlot extends Frame
{
  int gcount;//Use URLTodoubleArrays.ColumnCount() - 1 to set
  Panel left, right, top, bottom;
  Checkbox []cb;//, scaledTo;
  Button[]scaledTo;
  Button swap = new Button("XChange"), gon=new Button("on"),goff=new Button("off");
  CheckboxMenuItem axechg = new CheckboxMenuItem("Swap Axes"), 
    mthred = new CheckboxMenuItem("MultiThreaded Drawing"),
    threebutton= new CheckboxMenuItem("3-Button Zooming"),
    linebox = new CheckboxMenuItem("Zoom using lines/boxes");
  Choice ch = new Choice(), zch = new Choice();
  Label txt = new Label("Scaled to:", Label.CENTER);
  MenuBar pops = new MenuBar();
  Menu fil = new Menu("File"), keymen = new Menu("Key"), 
    extmen = new Menu("Axes",true), helpme = new Menu("Help"), 
    prefer = new Menu("Preferences",true), edit = new Menu("Edit");
  MenuItem groupext = new MenuItem("max/min..."), 
    gnormext = new MenuItem("Relative Scale"),
    gsnormext = new MenuItem("Zoom/Pan"),
    glog = new MenuItem("logorithms..."),
    docs = new MenuItem("Documentation"),
    whzup = new MenuItem("What's New"),
    about = new MenuItem("About"),
    ex = new MenuItem("Exit JIPC"),
    key = new MenuItem("Key Toggle"),
    refres=new MenuItem("Refresh Graph"),
    prefs = new MenuItem("Canvas Colors...");
  CanvasPanel cp;
  MouseZoom czp = new MouseZoom();
  LabelAdapter lab;
  RegRuledCanvasView screen;
  //DotGridRenderer grid = new DotGridRenderer();
  //OptimizeExtentsFilter[] nnf;
  MergedDataSource [] mds;
  DataLogScaleFilter[] scale;
  GroupLogScale gls = new GroupLogScale();
  DataLogScaleFilter  cursor_scale = new DataLogScaleFilter();
  GroupRenderer painter = new GroupRenderer();
  DataXYLineRenderer []xy;
  ExtentsAxesOrder scaling = new ExtentsAxesOrder();
  SpikeFilter [] spk;
  AxesOrderFilter[]aof;
  AxesOrderGroup aog= new AxesOrderGroup();
  SNormExtentsFilter []snormext;
  GroupSNormExtents gsnorm = new GroupSNormExtents();
  NormExtentsFilter []normext;
  GroupNormExtents gnorm = new GroupNormExtents();
  ExtentsFilter [] ext;
  LogDialog ldg = null;
  GroupExtents gext = new GroupExtents();
  CursorSource cursor = new CursorSource();
  LabelAdapter cursor_label;
  GridBagConstraints gbc = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();
  Frame document = new DocumentFrame("Documentation",
				     "http://lidar.ssec.wisc.edu/jipc/javaplot.doc"), 
    zup = new DocumentFrame("What's New","http://lidar.ssec.wisc.edu/jipc/whatsnew.doc"),
    intro = new IntroFrame();
  URL fromdial = null;
  /* Parameters: */
  int dataLine = 1, labelLine = 0, yAxis = 1;
  boolean units = false;
  Color[] colorarray={
    new Color(255,0,150),//pink
    Color.red,
    Color.orange,
    Color.yellow,
    Color.green,
    new Color(100,0,0),//brownish
    Color.blue,
    Color.cyan,
    new Color(0,0,150),//dkblue
    new Color(200,0,125),//cranberry
    Color.magenta};
  /*  Color[] colorarray={
    new Color(102,0,153),
    new Color(204,0,51),
    new Color(102,153,0),
    new Color(0,51,204),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,),
    new Color(,,)
  }; */   
  int ccount = 0;
  float[] rgb={0,0,1};
  double cres=.2;
  private Color newcol(){
    //if (++ccount>=colorarray.length)
    //ccount = 0;
    return colorarray[(ccount++)%colorarray.length];
  //System.out.println("DBG: new color's RGB vals = ( "+(int)(rgb[0]*255)+" , "+(int)(rgb[1]*255)+" , "+(int)(rgb[2]*255)+" )");
  //return(new Color((float)rgb[0],(float)rgb[1],(float)rgb[2]));
  }
  ColorsFrame colordial = new ColorsFrame(this);
  public synchronized boolean action(Event e, Object w){
    //try{
      //final URL base = new URL("file:/home/jpgarcia/JIPC/test.dat");
      Object chk = e.target;
      for (int z=0; z<gcount; z++){
	if (chk == cb[z]){
	  painter.SetVisible(xy[z],cb[z].getState());
	  //screen.repaint(125);
	  return true;
	}
      }
      if (chk == cb[gcount]){
	for (int z=0; z<gcount; z++){
	  cb[z].setState(cb[gcount].getState());
	  painter.SetVisible(xy[z],cb[gcount].getState());
	}
	return true;
      }
      if (chk == gon){
	for (int z=0; z<gcount; z++){
	  cb[z].setState(true);
	  painter.SetVisible(xy[z],true);
	}
	return true;
      }
      if (chk == goff){
	for (int z=0; z<gcount; z++){
	  cb[z].setState(false);
	  painter.SetVisible(xy[z],false);
	}
	return true;
      }
      //      if (chk == cbg)
      if(chk==mthred){
	for (int z=0; z<gcount; z++)
	  xy[z].ThreadPaint=mthred.getState();
	painter.ThreadPaint=mthred.getState();
	return true;
      }
      if(chk==threebutton){
	czp.ThreeButtonMouse = threebutton.getState();
	if(threebutton.getState())
	  zch.disable();
	else{
	  zch.enable();
	  if (zch.getSelectedIndex() ==0)
	    czp.SetPan(true);
	  else{
	    czp.SetPan(false);
	    if (zch.getSelectedIndex() == 1)
	      czp.SetZoomIn(true);
	    else
	      czp.SetZoomIn(false);
	  }
	}
	return true;
      }
      if(chk==linebox){
	czp.drawlines = linebox.getState();
	return true;
      }
      if(chk==refres){
	screen.repaint();
	return true;
      }
      if (chk == swap){
	//screen.repaint(125,0,0,50,50);
	/*double[] c = gext.getExtents();
	  System.out.println("DBG: Group Extents Dump");
	  for (int z = 0; z<c.length; z++)
	  System.out.println("DBG: gext.ext["+z+"] = " + c[z]);*/
	for (int z=0; z<gcount; z++){
	  cb[z].setState(!(cb[z].getState()));
	  painter.SetVisible(xy[z],cb[z].getState());
	}
	cb[gcount].setState(!(cb[gcount].getState()));
	return true;
      }	
      for (int z=0; z<gcount; z++)
	if (chk == scaledTo[z]){
	  cb[z].setState(true);
	  StringTokenizer tok = new StringTokenizer(scaledTo[z].getLabel());
	  scaledTo[gcount].setLabel("Scale: " +tok.nextToken());
	  gext.dialogDone(scaling.reorderExtents(normext[z].getBaseExtents()));
	  //screen.redraw();
	  screen.setExtents(ext[0]);
	  //screen.redraw();
	  cursor_scale.SetDestination( ext[0] );
	  painter.SetVisible(xy[z],true);
	  //lab.SetInput( gext );
	  return true;
	}
      if (chk == scaledTo[gcount]){
	scaledTo[gcount].setLabel("Scale: All");
	gext.dialogDone(scaling.reorderExtents(gext.allExtents()));
	//screen.redraw();
	screen.setExtents(ext[0]);
	//screen.redraw();
	cursor_scale.SetDestination( ext[0] );
	//lab.SetInput( gext );
	return true;
      }	    
      if (chk == axechg){
	if(axechg.getState())
	  aog.reorderAxes(aog.Y,aog.X);
	else
	  aog.reorderAxes(aog.X,aog.Y);
	return true;
      }
      if (chk == zch){
	//System.out.println("DBG: index = " + zch.getSelectedIndex());
	if (zch.getSelectedIndex() ==0)
	  czp.SetPan(true);
	else{
	  czp.SetPan(false);
	  if (zch.getSelectedIndex() == 1)
	    czp.SetZoomIn(true);
	  else
	    czp.SetZoomIn(false);
	}
	return true;
      }
      if (chk == ch){
	for (int z=0; z<gcount; z++)
	  if (ch.getSelectedItem() == painter.GetLabel(xy[z])){
	    gext.dialogDone(scaling.reorderExtents(normext[z].getBaseExtents()));
	    //screen.redraw();
	    screen.setExtents(ext[0]);
	    //screen.redraw();
	    cursor_scale.SetDestination( ext[0] );
	    //lab.SetInput( gext );
	  }
	if (ch.getSelectedItem() == "All"){
	  gext.dialogDone(scaling.reorderExtents(gext.allExtents()));
	  //screen.redraw();
	  screen.setExtents(ext[0]);
	  //screen.redraw();
	  cursor_scale.SetDestination( ext[0] );
	  //lab.SetInput( gext );
	}	    
	return true;
      }
      if (chk == groupext){ gext.Open();return true;}
      if (chk == gnormext){ gnorm.Open(); return true;}
      if (chk == gsnormext){ gsnorm.Open();return true;}
      if (chk == key){ painter.ToggleKeyVisible();return true;}
      if (chk == glog){ ldg.open(screen.getXState(), screen.getYState());return true;}
      if (chk == prefs){ openPrefs();return true;}
      if (chk == docs){ gimmehelp();return true;}
      if (chk == whzup){ zup.setVisible(true);return true;}
      if (chk == about){ meetme();return true;}
      if (chk == ex) {
	dispose();
	destroy();
	System.gc();
	//System.exit(0);
	return true;
      }
      //}catch(MalformedURLException mue){
      //System.out.println("Invalid URL");
      // }
    return false;
  }
  public void meetme(){
    if (intro == null)
      intro = new IntroFrame();
    intro.setVisible(true);
  }
  public void gimmehelp(){
    //if (document == null)
    //document = new HelpFrame(); 
    document.setVisible(true);
  }
  public void gatherPrefs(){
    switch(colordial.Pgcolor.getSelectedIndex()){
    case(0): 
      screen.setColor(Color.black);
      break;
    case(1): 
      screen.setColor(Color.darkGray);
      break;
    case(2): 
      screen.setColor(Color.gray);
      break;
    case(3): 
      screen.setColor(Color.lightGray);
      break;
    case(4): 
      screen.setColor(Color.white);
      break;
    }
    switch(colordial.Pbcolor.getSelectedIndex()){
    case(0): 
      screen.setBackgroundColor(Color.black);
      break;
    case(1): 
      screen.setBackgroundColor(Color.darkGray);
      break;
    case(2): 
      screen.setBackgroundColor(Color.gray);
      break;
    case(3): 
      screen.setBackgroundColor(Color.lightGray);
      break;
    case(4): 
      screen.setBackgroundColor(Color.white);
      break;
    }
    switch(colordial.Prcolor.getSelectedIndex()){
    case(0): 
      screen.setRulerBackColor(Color.black);
      break;
    case(1): 
      screen.setRulerBackColor(Color.darkGray);
      break;
    case(2): 
      screen.setRulerBackColor(Color.gray);
      break;
    case(3): 
      screen.setRulerBackColor(Color.lightGray);
      break;
    case(4): 
      screen.setRulerBackColor(Color.white);
      break;
    }
    screen.setExtents(gext);
  }
  public void openPrefs(){
    if (colordial == null){
      colordial=new ColorsFrame(this);
    }
    colordial.open();
  }
  public JavaPlot(String Earl,String DS, String LS, String US, String Yax){
    try{
      final URL base = new URL("http://lidar.ssec.wisc.edu/");
      fromdial = new URL(base, Earl);
    }catch(MalformedURLException mue){
      System.out.println("Invalid URL");
    }
    setLayout( new BorderLayout());
    //setSize(600,600);
      try { 
	cp = new CanvasPanel( 
			     Class.forName( "java.awt.Label" ),
			     Class.forName( "java.awt.Label" ),
			     Class.forName( "RegRuledCanvasView" ) ); 
      } catch( Exception e ) { 
	System.out.println( "Exception: "+e.toString() );
      }
      screen = (RegRuledCanvasView)cp.center;
      lab = new LabelAdapter();
      try{
	if (DS != null)
	  dataLine = Integer.parseInt(DS);
	if (LS != null)
	  labelLine = Integer.parseInt(LS);
	if (US != null)
	  units = !(US=="false");
	if (Yax != null)
	  yAxis = Integer.parseInt(Yax);
      }catch(NumberFormatException nfe){}
      URLTodoubleArrays 
	input=new URLTodoubleArrays(fromdial,dataLine,labelLine,units);
      gcount = input.ColumnCount() - 1;
      mds = new MergedDataSource[gcount];
      scale  = new DataLogScaleFilter[gcount];
      xy = new DataXYLineRenderer[gcount];
      spk = new SpikeFilter[gcount];
      aof = new AxesOrderFilter[gcount];
      //nnf = new OptimizeExtentsFilter[gcount];
      snormext = new SNormExtentsFilter[gcount];
      normext = new NormExtentsFilter[gcount];
      ext = new ExtentsFilter[gcount];
      cb = new Checkbox[gcount+1];
      scaledTo = new Button[gcount+1];
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==yAxis) z++;
	mds[pl] = new MergedDataSource(input.c(z),input.c(yAxis));
      }
      for (int z=0; z<gcount; z++){
	scale[z] = new DataLogScaleFilter();
	xy[z] = new DataXYLineRenderer();
	snormext[z] = new SNormExtentsFilter();
	normext[z] = new NormExtentsFilter();
	//nnf[z] = new OptimizeExtentsFilter();
	ext[z] = new ExtentsFilter();
	spk[z] = new SpikeFilter();
	aof[z] = new AxesOrderFilter();
	spk[z].SetInput( mds[z] );
	spk[z].SetXVariance( 100 );
	spk[z].SetYVariance( 1000 );
	spk[z].SetYRes( 5 );
	spk[z].SetXRes( 5 );
	aof[z].SetInput(spk[z]);
	aog.AddInput(aof[z]);
	//nnf[z].SetInput(spk[z]);
	normext[z].SetInput( aof[z] );
	//gnorm.AddInput( normext[z]);
	snormext[z].SetInput( normext[z] );
	gsnorm.AddInput( snormext[z] );
	ext[z].SetInput(snormext[z]);
	gext.AddInput( ext[z] );
	scale[z].SetInput(snormext[z] );
	scale[z].SetSource( gext);//snormext[z] );
	scale[z].SetDestination( screen.dataView() );
	gls.AddFilter(scale[z]);
	xy[z].SetInput( scale[z] );
	xy[z].SetColor( newcol() );
      }
      aog.AddInput(scaling);
      painter.SetFont( new Font("Times", Font.BOLD, 12));
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==yAxis) z++;
	painter.AddInput( xy[pl], 		       
			  input.h(z) + "(" + input.u(z) + ") vs. " + 
			  input.h(yAxis) + "(" + input.u(yAxis) + ")" );      
      }
      for (int z=0; z<gcount; z++){
	scaledTo[z] = new Button(painter.GetLabel(xy[z]));
	//scaledTo[z].setCheckboxGroup(cbg);
	cb[z] = new Checkbox("-");//painter.GetLabel(xy[z]));
	cb[z].setState(true);
	Color col=xy[z].color();
	scaledTo[z].setForeground(col);
	//scaledTo[z].setForeground(Color.lightGray);
	//if((col.getRed()<100) && (col.getGreen()<100) && (col.getBlue()<100))
	/*if((col.getRed()*col.getGreen()*col.getBlue()<750000))
	  cb[z].setForeground(Color.white);*/
      }
      cb[gcount] = new Checkbox("-");
      cb[gcount].setState(true);
      scaledTo[gcount] = new Button("Scale: All");
      //scaledTo[gcount].setForeground(Color.lightGray);
      //scaledTo[gcount].setBackground(Color.white);
      //scaledTo[gcount].setCheckboxGroup(cbg);
      //cbg.setCurrent(scaledTo[gcount]);
      //screen.setBackgroundColor(Color.black);
      input = null;

      zch.addItem("Pan");
      zch.addItem("Zoom In");
      zch.addItem("Zoom Out");
      
      lab.SetInput( gext );
      lab.round = true;
      lab.setRound(4);
      lab.AttachBottomLeft( (Label)cp.bl );
      lab.AttachTopRight( (Label)cp.tr );

      screen.SetCursorOutput( cursor ); 
      cursor_scale.invert=true;
      //cursor_scale.scaleBeforeLog=true;
      cursor_scale.setCaching(false);
      cursor_scale.SetSource( screen.dataView() );
      cursor_scale.SetDestination( gext );
      cursor_scale.SetInput( cursor );     
      cursor_scale.setCaching(false);
      gls.AddFilter(cursor_scale);
      ldg = new LogDialog();
      //ldg.Add(gls);
      //ldg.Add(grid);
       ldg.Add(gls);
       ldg.Add(gsnorm);
      ldg.Add(screen);
      cursor_label = new LabelAdapter();
      cursor_label.left="Mouse = ";
      cursor_label.SetInput( cursor_scale );
      cursor_label.AttachCursor( cp.bm );
      cursor_label.round=true;      

      screen.hostframe=this;
      //grid.SetHorizontalDivisions( 10 );
      //grid.SetVerticalDivisions( 10 );
      //grid.SetInput( screen.dataView() );
      screen.setExtents( ext[0] );
      //screen.AddBackgroundRenderer( grid);

      czp.SetCanvasView(screen);
      //czp.SetCursorSource(cursor);
      czp.SetExtents( gsnorm );
      screen.AddBackgroundRenderer( czp);
      
      mthred.setState(true);
      prefer.add(mthred);
      prefer.add(threebutton);
      prefer.add(linebox);
      prefer.add(prefs);
      fil.add(refres);
      fil.addSeparator();
      fil.add(ex);
      helpme.add(docs);
      helpme.addSeparator();
      helpme.add(whzup);
      helpme.add(about);
      keymen.add(key);
      extmen.add(groupext);
      //extmen.add(gnormext);
      //extmen.add(gsnormext);
      extmen.add(glog);
      extmen.add(axechg);
      edit.add(extmen);
      edit.add(prefer);
      pops.add(fil);
      pops.add(edit);
      pops.add(helpme);
      pops.setHelpMenu(helpme);
      setMenuBar(pops);
      right = new Panel();
      //lright = new Panel();
      //rright = new Panel();
      right.setLayout(gbl);
      //lright.setLayout(new GridLayout(gcount+1,1));
      //rright.setLayout(new GridLayout(gcount+1,1));
      gbc.fill = GridBagConstraints.BOTH;
      ch.addItem("All");
      for (int z=0; z<gcount; z++){
	//ch.addItem(painter.GetLabel(xy[z]));
	addtoRight( cb[z],scaledTo[z]);
      }
      gbc.gridy=loccount;
      gbc.gridx=0;
      gbc.weightx =0;
      gbc.gridwidth = 1;
      gbc.anchor = GridBagConstraints.EAST;
      gbc.fill = GridBagConstraints.NONE;
      gbl.setConstraints(gon,gbc);
      right.add(gon);
      gbc.gridx=1;
      gbc.anchor = GridBagConstraints.WEST;
      gbl.setConstraints(goff,gbc);
      right.add(goff);
      //gbl.setConstraints(cb[gcount],gbc);
      //right.add(cb[gcount]);
      gbc.gridy=loccount;
      gbc.gridx=2;
      gbc.weightx =1;
      //gbc.gridheight=2;
      gbc.gridwidth = 1;
      gbc.anchor = GridBagConstraints.CENTER;
      gbc.fill = GridBagConstraints.BOTH;
      gbl.setConstraints(scaledTo[gcount],gbc);
      right.add(scaledTo[gcount]);
      gbc.gridy=loccount+2;
      gbc.gridx=0;
      //gbc.gridheight=1;
      gbc.weightx =1;
      gbc.gridwidth = 2;
      gbc.fill = GridBagConstraints.NONE;
      gbl.setConstraints(swap,gbc);
      right.add(swap);
      gbc.gridx=2;
      gbc.weightx =1;
      gbc.gridwidth = 1;
      gbl.setConstraints(zch,gbc);
      right.add(zch);
     left = new Panel();
      left.setLayout(new GridLayout(1,1));
      left.add( "",cp );
      left.setVisible(true);
      left.validate();
      //right.add( "",txt );
      //right.add( "",ch );
      //right.add("", lright);
      //right.add("",rright);
      //lright.setVisible(true);
      //lright.validate();
      //rright.setVisible(true);
      //rright.validate();
      right.setVisible(true);
      right.validate();
      validate();
      add("Center",left);
      add("East",right);
      validate();
      left.setVisible(true);
      right.setVisible(true);
      screen.SetRenderer( painter );
     }
  int loccount = 0;
  public void addtoRight(Checkbox bx, Button sel){
    gbc.weightx =0;
    gbc.weighty =1;
    gbc.gridx = 0;
    gbc.gridy = loccount;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbl.setConstraints(bx,gbc);
    right.add(bx);
    gbc.gridx=1;
    gbc.weightx =1;
    gbc.gridwidth = 2;
    gbl.setConstraints(sel,gbc);
    right.add(sel);
    loccount++;
    //lright.add(bx);
    //rright.add(sel);
  }
  public boolean mouseEnter(Event evt, int  x, int  y) 
    { 
      setCursor(Frame.DEFAULT_CURSOR);
      return true;
    }
  public boolean mouseExit(Event evt, int  x, int  y) 
    { 
      setCursor(Frame.DEFAULT_CURSOR);      
      return true;
    }
  public void destroy(){
    document.dispose();
    intro.dispose();
    colordial.dispose();
    zup.dispose();
  }
}
