/**
 *
 * Thu Apr 02 00:00:00 1998 LogBaseDialog.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.util.Vector;
//import java.util.Vector;
public class LogDialog extends Frame
{
  private Vector logcap = new Vector();
  private Button OK, Cancel, Max, Apply, Reset;
  private Panel nsew, buttons;
  private TextField  x = new TextField() ,y = new TextField();
  private double ox, oy, nx,ny;
  private int dim=2;
  public LogDialog(){
    build();
  }
  public void Add(LogBaseCapable lc){
    logcap.addElement(lc);
  }
  public void Remove(LogBaseCapable lc){
    if (logcap.contains(lc))
      logcap.removeElement(lc);
  }
  public void open(double xlog, double ylog){
    nx=ox= xlog;
    ny=oy= ylog;
    refill();
    setVisible(true);
  }
  private void refill()
    {
      x.setText( Double.toString(nx));
      y.setText( Double.toString(ny));
    }
  private static double fetch( TextComponent it, double old )
    {
      try { 
	return (new Double( it.getText() )).doubleValue();
      } catch ( Exception e ) { 
	return old;
      }
    }
  
  private void llifer() // opposite of a refill
    { 
      reconstruct(fetch(x,ox),fetch(y,oy));
    }

  private void build() 
    {
      setLayout( new BorderLayout() );
      setResizable(false);
      nsew = new Panel();
      add( "North", nsew );
      buttons = new Panel();
      add( "South", buttons );
      
      Max = new Button( "Linear" );
      Max.setBackground( Color.orange );
      buttons.add( Max );
      
      OK = new Button( "Okay" );
      OK.setBackground( Color.green );
      buttons.add( OK );
      
      Cancel = new Button( "Cancel" );
      Cancel.setBackground( Color.red );
      buttons.add( Cancel );
      
      Apply = new Button( "Apply" );
      Apply.setBackground( Color.green );
      buttons.add( Apply );
      
      Reset = new Button( "Reset" );
      Reset.setBackground( Color.orange );
      buttons.add( Reset );
      
      nsew.setLayout(new GridLayout(2,dim));
      nsew.add(new Label("X-Axis", Label.CENTER));
      nsew.add( new Label("Y-Axis", Label.CENTER));
      nsew.add(x);
      nsew.add(y);
      resize(300,150);
      setTitle("Logorithmic Axes");
      nsew.validate();
      buttons.validate();
      validate();
    }
  private synchronized boolean reconstruct(double a, double b){
    nx = a;
    ny = b;
    for (int q = 0; q<logcap.size(); q++){
      LogBaseCapable lc =  (LogBaseCapable)logcap.elementAt(q);
      //System.out.println("DBG: logging "+ lc.toString());
      //System.out.println("DBG: " + a + ", " + b);
      lc.setXBase(nx);
      //System.out.println("DBG a done");
      lc.setYBase(ny);
      //System.out.println("DBG b done");
    }
    nx = a;
    ny = b;
    return true;
  }

  public boolean handleEvent( Event evt ) 
    {
      if ((evt.id!=Event.ACTION_EVENT) && (evt.key != Event.ENTER))
	return super.handleEvent( evt );
      if (evt.target==(Object)OK) {
	llifer( );
	//reconstruct(fetch(x,ox), fetch(y,oy));
	setVisible(false);
	//rcv.repaint();
	return true;
      }
      if (evt.target==(Object)Apply) {
	llifer( );
	//reconstruct(fetch(x,ox), fetch(y,oy));
	//rcv.repaint();
	refill();
	return true;
        }
      if (evt.target==(Object)Cancel) { 			
	reconstruct(ox,oy);
	//rcv.repaint();
	setVisible(false);
	return true;
        } 
      if (evt.target==(Object)Max) { 
	reconstruct(1.0,1.0);
	refill();
	return true;
        }
      if(evt.target==(Object)Reset){
	reconstruct(ox,oy);
  	refill();
	return true;
        }
      if(evt.key == evt.ENTER){
	llifer( );
	//reconstruct(fetch(x,ox), fetch(y,oy));
	//rcv.repaint(125);
	refill();
	return true;
        }
      return super.handleEvent( evt );
    }
}

