/**
 *
 * Mon Apr 20 01:00:00 1998 MouseZoom.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.awt.event.*;
import java.util.Observable;
import java.util.Observer;

class MouseZoom extends DataRenderer implements Observer
{
  //private boolean [] bas = {false,false};
  private ExtentsFilter ext = null;
  private CanvasView cv = null;
  //private CursorSource cs = null;
  private final int err = 3;
  public boolean ThreeButtonMouse = false;
  public boolean drawlines = false;
  //private Graphics g = null;
  private int inX=-1, inY=-1, outX=-1, outY=-1;
  private boolean pan = true, zoomin = false, clickzoom = false;
  public void SetCanvasView(CanvasView _cv){
    if (cv != null)
      cv.getCursorSource().deleteObserver(this);
    if(_cv.getCursorSource() != null){
      cv = _cv;
      cv.getCursorSource().addObserver(this);
    }else
      System.out.println("MouseZoom inactive.  Host CanvasView does not Mouse Output set.");
  }
  /*  public void SetCursorSource(CursorSource _cs){
    if (cs != null)
      cs.deleteObserver(this);
    cs = _cs;
    if (cs != null)
      cs.addObserver(this);
  }*/
  // public void setXBase(double n){ bas[0] = (n!=1.0);}
  //public void setYBase(double n){ bas[1] = (n!=1.0);}
  //public void setZBase(double n){}
  public synchronized boolean GetPan(){ return pan;}
  public synchronized void SetPan(boolean pn){ pan = pn;}
  public synchronized boolean TogglePan(){ return (pan = !pan);}
  //public synchronized Color GetColor(){ return iconcolor;}
  //public synchronized void SetColor(Color pn){ iconcolor = pn;}
  /*  public synchronized int GetSize(){ return Size;}
  public synchronized void SetSize(int pn){ Size = pn;}*/
  public synchronized boolean GetZoomIn(){ return zoomin;}
  public synchronized void SetZoomIn(boolean pn){ zoomin = pn;}
  public synchronized boolean ToggleZoomIn(){ return (zoomin = !zoomin);}
  public void SetExtents(SNormExtentsFilter _in){ 
    //if(ext!= null) ext.deleteObserver(this);
    ext = (ExtentsFilter) _in;
    //if(ext!= null) ext.addObserver(this);
    };
  public void SetExtents(GroupSNormExtents _in){
    //if(ext!= null) ext.deleteObserver(this);
    ext = (ExtentsFilter) _in; 
    //if(ext!= null) ext.addObserver(this);
  };
  public void updateCoords(){
    //System.out.println("DBG: start = (" + inX + "," + inY + ")  curr = ("+outX+","+outY+") button = "+cv.getCursorSource().getButton());
    double[] dat = cv.getCursorSource().getData();
    //System.out.println("DBG:  coords ("+dat[0]+","+dat[1]+")  button = "+cv.getCursorSource().getButton());
    if (inX+inY<0)//no initial coords
      if (cv.getCursorSource().getButton() ==0){//not pressed
	//System.out.println("DBG: nothing to do");
	return; // no action
      }else{//pressed
	if(!clickzoom){
	  //System.out.println("DBG: coords saved");
	  inX=(int)dat[0];// save initial click coords
	  inY=(int)dat[1];
	  if(ThreeButtonMouse)
	    switch(cv.getCursorSource().getButton()){//save button mode
	    case(1):// LEFT = panning
	      pan = true;
	      break;
	    case(3):// MID = zoom in
	      pan = false;
	      zoomin = true;
	      break;
	    case(2):// RIGHT = zoom out
	      pan = false;
	      zoomin = false;
	      break;
	    }
	  if(! pan)
	    cv.cursor(Frame.HAND_CURSOR);      	  
	  else
	    cv.cursor(Frame.MOVE_CURSOR);      	  
	} //else
	//clickzoom = false;
      }
    else{ // initial coords gotten already
      if(cv.getCursorSource().getButton()==0){//released
	if ((Math.abs(inX-(int)dat[0])<=err) && (Math.abs(inY-(int)dat[1])<=err)){// same
	  //System.out.println("DBG: not dragged");
	  //System.out.println("DBG: clickzoom on");
	  clickzoom = true;// clickzoom mode
	}else// release on other coord
	  if (!clickzoom){//IS end of a drag
	    //System.out.println("DBG: resize");
	    ResizeAction((int)dat[0], (int)dat[1]); // resize;
	    return;
	  }
    } else 
	if (clickzoom){//clicked again in click zoom mode
	  //System.out.println("DBG: clickzoom off");
	  clickzoom = false;
	  ResizeAction((int)dat[0], (int)dat[1]); // resize;
	  return;
	}
      int ox, oy;
      if (outX+outY >0){
	ox = outX;
	oy = outY;
      } else {
	ox =(int)dat[0];
	oy = (int)dat[1];
      }
      outX=(int)dat[0];
      outY=(int)dat[1];
      //System.out.println("DBG: painting box");
      if(drawlines)
	cv.repaint(125,Math.min(outX,Math.min(ox,inX))-3,
	       Math.min(outY,Math.min(oy,inY))-3,
	       Math.max(outX,Math.max(ox,inX))-Math.min(outX,Math.min(ox,inX))+6,
	       Math.max(outY,Math.max(oy,inY))-Math.min(outY,Math.min(oy,inY))+6);
      else
	if((ox==outX)&&(oy==outY))//((inX==outX)&&(inY==outY))
	  cv.repaint(125,inX-4,inY-4,9,9);
	  //draw(cv.getGraphics());
      //cv.repaint();
    }
  }
  private boolean ignorenextupdate = false;
  private synchronized void ResizeAction(int x, int y){
    double[] cdv= (cv.dataView().getExtents()),
      out = new double[4], cach = new double[4];
    cv.cursor(Frame.CROSSHAIR_CURSOR);
    /*if(bas[0]){
      double len = Math.abs(cdv[1]-cdv[0]);
      cach[0]=((len*Math.log(inX+1))/Math.log(len))-1;
      cach[1]=((len*Math.log(x+1))/Math.log(len))-1;
      } else {*/
    cach[0] = inX;
    cach[1] = x;
    /*}
      if(bas[1]){
      double len = Math.abs(cdv[3]-cdv[2]);
      cach[2]=((len*Math.log(inY+1))/Math.log(len))-1;
      cach[3]=((len*Math.log(y+1))/Math.log(len))-1;
      } else {*/
    cach[2] = inY;
    cach[3] = y;
    //}
    if (pan){
      //System.out.println("DBG: Panning..");
      out[0] = -1 + 2*((cach[0] - cach[1])/(cdv[1] - cdv[0]));
      out[1] = 1 + 2*((cach[0] - cach[1])/(cdv[1] - cdv[0]));
      out[2] = -1 + 2*((cach[2] - cach[3])/(cdv[3] - cdv[2]));
      out[3] = 1 + 2*((cach[2] - cach[3])/(cdv[3] - cdv[2]));
    } else{
      if (zoomin){
	//System.out.println("DBG: Zooming In..");
	double inl = cach[0] - cdv[0],
	  getl = cach[1] - cdv[0],
	  len = (cdv[1] - cdv[0])/2;
	out[0] = (Math.min(inl,getl)/len) -1;
	out[1] = (Math.max(inl,getl)/len) -1;
	inl = cach[2] - cdv[2];
	getl = cach[3] - cdv[2];
	len = (cdv[3] - cdv[2])/2;
	out[3] = (Math.min(inl,getl)/len) -1;
	out[2] = (Math.max(inl,getl)/len) -1;
      } else {
	//System.out.println("DBG: Zooming Out..");
	double inl = Math.abs(cach[0] - cach[1]),
	  ol = 2,
	  len = (cdv[1] - cdv[0]);
	out[0] = ((cdv[0]-(Math.min(cach[0], cach[1])))/(len-inl))*(ol*(len/inl)-ol)-1;
	out[1] = ((cdv[1]-(Math.max(cach[0], cach[1])))/(len-inl))*(ol*(len/inl)-ol)+1;
	inl = Math.abs(cach[2] - cach[3]);
	len = (cdv[3] - cdv[2]);
	out[2] = -((cdv[2]-(Math.min(cach[2], cach[3])))/(len-inl))*(ol*(len/inl)-ol)+1;
	out[3] = -((cdv[3]-(Math.max(cach[2], cach[3])))/(len-inl))*(ol*(len/inl)-ol)-1;
      }
    } 
      inX=inY=outX=outY=-1;
      //for (int c = 0; c< 4; c++)
      //System.out.println("DBG: Out[" + c + "] = " + out[c]);
      ext.dialogDone(out);
      /*for (int c = 0; c< 4; c++)
	System.out.println("DBG: Post: Out[" + c + "] = " + out[c]);*/
      cv.update(this,null);
      
    }
  public void draw(Graphics g){
    if(inX+inY+outX+outY>0)
      if(pan){
	g.setColor(Color.red);
	if(drawlines)
	  g.drawLine(inX,inY,outX,outY);
	else{
	  g.drawLine(inX-3,inY-3,inX+3,inY+3);
	  g.drawLine(inX-3,inY+3,inX+3,inY-3);
	}
      } else {
	if(zoomin)
	  g.setColor(Color.red);
	else
	  g.setColor(Color.blue);
	if(drawlines)
	  g.drawRect(Math.min(inX,outX),Math.min(inY,outY),
		     Math.abs(inX-outX),Math.abs(inY-outY));
	else{
	  g.drawRect(inX-3,inY-3,7,7);
	  g.drawLine(inX,inY,inX,inY);
	}
      }
    ignorenextupdate=true;
  }
  public void update(Observable ob, Object in)
    {
      //System.out.println("DBG: MouseZoom::update called");
      //if (!(bas[0] || bas[1]))
      //if(!drawlines)
      if(ignorenextupdate)
	ignorenextupdate=false;
      else
	updateCoords();
      setChanged(); notifyObservers();
    }
}
