/**
 *
 * Thu Apr 02 00:00:00 1998 ObservationFunnel.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.*;

public class ObservationFunnel extends Observable implements Observer{
  private Vector rep = new Vector();
  public synchronized void reset(){ rep.removeAllElements();}
  public synchronized void update(Observable o, Object arg){
    setChanged();
    if (rep.isEmpty())
      notifyObservers();
    else if(rep.contains(o)){
      notifyObservers();
      reset();
    }
    rep.addElement(o);
  }
}
