/**
 *
 * Thu Apr 16 01:00:00 1998 PrefsFrame.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.awt.*;
import java.util.*;

public class PrefsFrame extends Frame{
  public Label Pxaxis = new Label("X Axis Rulers",Label.LEFT), 
    Pyaxis = new Label("Y Axis Rulers",Label.LEFT),
    Pgcoll = new Label("Grid Color",Label.RIGHT),
    Pbcoll = new Label("Background",Label.RIGHT),
    Pkeyloc = new Label(" ",Label.CENTER),
    Pkeysep = new Label(" ",Label.CENTER);
  public Checkbox Pleft = new Checkbox("Left"),
    Pright=new Checkbox("Right"),
    Pbottom = new Checkbox("Bottom"),
    Ptop = new Checkbox("Top"),
    mouse = new Checkbox("3 Button Zooming"),
    lines = new Checkbox("Zoom using lines/boxes"),
    Pkey = new Checkbox("MultiThreaded Drawing");
  public Choice Pgcolor = new Choice(),
    Pbcolor = new Choice();
  public TextField Pkx = new TextField("11"),
    Pky = new TextField("10");
  public Button Pok = new Button("OK"),
    Papply = new Button("Apply");
  private JavaPlot host;
  private GridBagConstraints gbc = new GridBagConstraints();
  private GridBagLayout gbl = new GridBagLayout();
  private final float [] wx={ 1,1,0, 1,1,1,0, 1,1, 1,1, 1,1, 1,1 };
  private final float [] wy={ 1,1,0, 1,1,1,0, 1,1, 1,1, 1,1, 1,1 };
  private final int [] gx = { 0,4,5, 0,0,4,5, 4,5, 0,0, 0,4, 4,5 };
  private final int [] gy = { 0,0,0, 1,2,1,1, 2,2, 3,1, 4,4, 5,5 };
  private final int [] gw = { 4,1,1, 4,4,1,1, 1,1, 4,4, 4,2, 1,1 };
  private final int [] gh = { 1,1,1, 1,1,1,1, 1,1, 1,1, 1,1, 1,1 };
  public PrefsFrame(JavaPlot _host){
    super("Preferences");
    host = _host;
    buildPrefs();
  }
  public void open(){
    setVisible(true);
  }
  public synchronized boolean action(Event e, Object w){
    Object chk = e.target;
    /*if (chk == Pkey) {
      //painter.SetKeyVisible(Pkey.getState());
      Pkx.setEnabled(Pkey.getState());
      Pky.setEnabled(Pkey.getState());
      Pkeyloc.setEnabled(Pkey.getState());
      Pkeysep.setEnabled(Pkey.getState());
    }*/
    if (chk == Papply)
      host.gatherPrefs();
    if (chk == Pok){
      host.gatherPrefs();
      setVisible(false);
    }
    return true;
  }      
  private void buildPrefs(){
      Vector davec = new Vector();
      Pleft.setState(true);
      Pright.setState(true);
      Pbottom.setState(true);
      Ptop.setState(true);
      Pkey.setState(true);
      Pgcolor.addItem("Black");
      Pgcolor.addItem("DkGray");
      Pgcolor.addItem("Gray");
      Pgcolor.addItem("LtGray");
      Pgcolor.addItem("White");
      //Pgcolor.select("Black");
      Pbcolor.addItem("Black");
      Pbcolor.addItem("DkGray");
      Pbcolor.addItem("Gray");
      Pbcolor.addItem("LtGray");
      Pbcolor.addItem("White");
      Pbcolor.select("LtGray");
      /*Pkx.setEnabled(false);
      Pky.setEnabled(false);
      Pkeyloc.setEnabled(false);
      Pkeysep.setEnabled(false);*/
      davec.addElement(Pkey);
      davec.addElement(Pgcoll);
      davec.addElement(Pgcolor);
      davec.addElement(mouse);
      //davec.addElement(Pkx);
      davec.addElement(lines);
      //davec.addElement(Pky);
      davec.addElement(Pbcoll);
      davec.addElement(Pbcolor);
      //davec.addElement(Pxaxis);
      //davec.addElement(Pyaxis);
      //davec.addElement(Ptop);
      //davec.addElement(Pleft);
      //davec.addElement(Pbottom);
      //davec.addElement(Pright);
      davec.addElement(Papply);
      davec.addElement(Pok);
      //davec.addElement(mouse);
    setLayout(gbl);
    gbc.fill = GridBagConstraints.BOTH;
    for(int i=0; i<davec.size();i++){
      Component l = (Component)davec.elementAt(i);
      gbc.weightx = wx[i];
      gbc.weighty = wy[i];
      gbc.gridx = gx[i];
      gbc.gridy = gy[i];
      gbc.gridwidth = gw[i];
      gbc.gridheight = gh[i];
      gbl.setConstraints(l,gbc);
      add(l);
      //if (i <9)add(l);
      //if (i>14) add(l);
    }
    resize(400,125);
    validate();
  }
}
