/**
 *
 * Fri Feb 25 12:49:56 2000 SingleShotFilter.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observable;
import java.util.Observer;

public class SingleShotFilter extends DataFilter
/** divorces update signal from input source
    useful for eliminating infinite update loops
  */
{
	private Observable trigger = null;

	public void SetInput( DataSource _in )
        { in = _in;
          if (in!=null) {
             setCaching(in.cacheEnabled());
          }
          setChanged(); notifyObservers();
        }
                
	public void SetTrigger( Observable _trig )
	{ if (trigger!=null) trigger.deleteObserver(this);
	  trigger = _trig; 
	  if (trigger!=null) { 
	   	trigger.addObserver(this);	  
	  	setChanged(); notifyObservers(); 
	  	}
	}
		
	public void update( Observable o, Object arg )
	{
		if (o==(Observable)trigger) { setChanged(); notifyObservers(); }
	}
}

