/**
 *
 * Mon Jun 23 01:00:00 1997 tests/test3.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.applet.Applet;

class DataTestSource extends DataSource
{
	public double [] data = { 0,-1, 1,2, 3,-5, 6,12, 8,14 };
	public double [] extent = { 0,8, -5,14 };
	public int[] dim = { 2, 5 };
	
	public double[] getData() { return data; }
	public double[] getExtents() { return extent; }
	public int[] getDimensions() { return dim; }
}


public class test3 extends Applet
{
	CanvasPanel cp;
	LabelAdapter lab;

	DataTestSource dts = new DataTestSource();
	ExtentsDialogFilter scail = new ExtentsDialogFilter();
	ZeroLineAddingFilter zero = new ZeroLineAddingFilter();
	CanvasView screen; 
	DataLinearScaleFilter scale = new DataLinearScaleFilter();
	DataXYLineRenderer painter = new DataXYLineRenderer();

	CursorSource cursor = new CursorSource();
	DataLinearScaleFilter cursor_scale = new DataLinearScaleFilter();
	LabelAdapter cursor_label;

	GridRenderer grid = new GridRenderer();
	DataLinearScaleFilter anno_scale = new DataLinearScaleFilter();
	AnnotationRenderer anno = new AnnotationRenderer();

	public boolean action( Event evt, Object what )
	{
		if (evt.id==Event.MOUSE_UP) {
			System.out.println("here we go!");
			scail.Open();
			return true;
		}
		else return super.action( evt, what );
	}
	
	public void init()
	{
		super.init();
		
		setLayout( new GridLayout(1,1) );

		try { cp = new CanvasPanel( 
			Class.forName( "java.awt.Label" ),
			Class.forName( "java.awt.Label" ),
			// Class.forName( "java.awt.TextField" ),
			Class.forName( "CanvasView" ) ); 
			} catch( Exception e ) { 
				System.out.println( "Exception: "+e.toString() );
		}
		screen = (CanvasView)cp.center;
		lab = new LabelAdapter();

		scail.SetInput( dts );   // ultimately should be self? 
		scail.SetMaxSource( dts );
		zero.SetInput( scail );
		// zero.SetZeroLine( false );
		scale.SetSource( zero );
		scale.SetDestination( screen.dataView() );
		scale.SetInput( zero );
		painter.SetInput( scale );
		screen.SetRenderer(painter);
		lab.SetInput( zero );
		lab.AttachBottomLeft( (Label)cp.bl );
		lab.AttachTopRight( (Label)cp.tr );

// now let's create a mouse cursor 
		screen.SetCursorOutput( cursor ); 
		cursor_scale.SetSource( screen.dataView() );
		cursor_scale.SetDestination( zero );  // reverse it! 
		cursor_scale.SetInput( cursor );     
		cursor_label = new LabelAdapter();
		cursor_label.SetInput( cursor_scale );
		cursor_label.AttachCursor( cp.bm );

		grid.SetHorizontalDivisions( 10 );
		grid.SetVerticalDivisions( 10 );
		grid.SetInput( screen.dataView() );
		screen.AddBackgroundRenderer( grid );

// how about some annotations
		Annotation annie = new Annotation();
		annie.x=2;
		annie.y=3;
		annie.text="hello";
		anno_scale.SetSource( zero );
		anno_scale.SetDestination( screen.dataView() );  
		anno.SetCoordFilter( anno_scale );
		anno.AddAnnotation( annie );
		screen.AddBackgroundRenderer( anno );
		
		add( cp );
		scail.Open();
	}

}
		
		
