/**
 *
 * Thu Oct 09 01:00:00 1997 tests/testa.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.applet.Applet;

class DataTestSource extends DataSource
{
	public double [] data = { 0,-1, 1,2, 3,-5, 6,12, 8,14 };
	public double [] extent = { 0,8, -5,14 };
	public int[] dim = { 2, 5 };
	
	public double[] getData() { return data; }
	public double[] getExtents() { return extent; }
	public int[] getDimensions() { return dim; }
}


public class testa extends Applet
{
  CanvasPanel cp; //desktop
  LabelAdapter lab; //add on for notes

  DataTestSource dts = new DataTestSource(); //data source
  ExtentsDialogFilter scail = new ExtentsDialogFilter();// rescale dialog filt.
  ZeroLineAddingFilter zero = new ZeroLineAddingFilter();// buh
  CanvasView screen; //drawing tablet to be put on desktop
  DataLinearScaleFilter scale = new DataLinearScaleFilter();// buh
  DataXYLineRenderer painter = new DataXYLineRenderer();// 2D line renderer

  CursorSource cursor = new CursorSource();//mouse tracker
  DataLinearScaleFilter cursor_scale = new DataLinearScaleFilter();//mouse's scale
  LabelAdapter cursor_label;//mouse's coordinate's output location

  GridRenderer grid = new GridRenderer();// adds grid
  DataLinearScaleFilter anno_scale = new DataLinearScaleFilter();//note scaling
  AnnotationRenderer anno = new AnnotationRenderer();// note renderer

	public boolean action( Event evt, Object what )
	{
	  if (evt.id==Event.MOUSE_UP) { //if mouse button released
	    System.out.println("here we go!");//hi
	    scail.Open();//open scail dialog
			return true;
		}
		else return super.action( evt, what );
	}
	
	public void init()
	{
	  super.init();// init supreme
		
	  setLayout( new GridLayout(1,1) );//streching layout

	  try { cp = new CanvasPanel( //new panel consisting of:
				     Class.forName( "java.awt.Label" ),//2
				     Class.forName( "java.awt.Label" ),//labels
			// Class.forName( "java.awt.TextField" ),
				     Class.forName( "CanvasView" ) ); //+ canvas
	  } catch( Exception e ) { // Exception handling
				System.out.println( "Exception: "+e.toString() );
		}
	  screen = (CanvasView)cp.center;//put canvas on desktop
	  lab = new LabelAdapter();// create label adapter

		scail.SetInput( dts );   // ultimately should be self? 
		scail.SetMaxSource( dts );
		zero.SetInput( scail );
		// zero.SetZeroLine( false );
		scale.SetSource( zero );//set origin to 0
		scale.SetDestination( screen.dataView() );//make scale useful
		scale.SetInput( zero );//make origin
		painter.SetColor(Color.red);
		painter.SetInput( scale );//renderer input == scale
		screen.SetRenderer(painter);//renderer output =>screen
		lab.SetInput( zero );//init the label writer
		lab.AttachBottomLeft( (Label)cp.bl );// set the max and mins
		lab.AttachTopRight( (Label)cp.tr );//for the label writer

// now let's create a mouse cursor 
		screen.SetCursorOutput( cursor ); //keep track of mouse
		cursor_scale.SetSource( screen.dataView() );//who's measurement
		cursor_scale.SetDestination( zero );  // reverse it! 
		cursor_scale.SetInput( cursor );     //
		cursor_label = new LabelAdapter();// mouse labels
		cursor_label.SetInput( cursor_scale );//coords
		cursor_label.AttachCursor( cp.bm );//

		grid.SetHorizontalDivisions( 10 );//gridding
		grid.SetVerticalDivisions( 10 );//more grid
		grid.SetInput( screen.dataView() );//where to
		screen.AddBackgroundRenderer( grid );// let them know it

// how about some annotations
		Annotation annie = new Annotation();//new note
		annie.x=2;//location in plotting coords
		annie.y=3;
		annie.text="hello";//label
		anno_scale.SetSource( zero );//init origin
		anno_scale.SetDestination( screen.dataView() );  // set locat.
		anno.SetCoordFilter( anno_scale );//setscale
		anno.AddAnnotation( annie );//write
		screen.AddBackgroundRenderer( anno );//add to desk
		
		add( cp );//add setup to current window
		scail.Open();// open scale dialog
	}
}
		
		
