/**
 *
 * Fri Nov 07 00:00:00 1997 tests/testf.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class testf extends Applet implements ActionListener
{

        MenuBar mbar = new MenuBar();
        Menu file = new Menu("File"), ops = new Menu("Options");
        MenuItem open=new MenuItem("Open..."),refresh=new MenuItem("Refresh"),ext=new MenuItem("Extents"),ext2=new MenuItem("NormExt"),ext3 = new MenuItem("Zoom"), key = new MenuItem("Key Toggle");
        Frame mainFr;
        FileDialog files;
	CanvasPanel cp;
	LabelAdapter lab;

  //	DataTestSource dts = new DataTestSource();
  //    DataTestSource2 dtst = new DataTestSource2();
	ExtentsFilter scail = new ExtentsFilter(), sca2 = new ExtentsFilter();
	ZeroLineAddingFilter zero = new ZeroLineAddingFilter(), z2 = new ZeroLineAddingFilter();
	CanvasView screen; 
	ListTodoubleArrays infile = null;
	MergedDataSource dts = null, dtst = null, dts3 = null;
	DataLinearScaleFilter scale = new DataLinearScaleFilter(), sc2 = new DataLinearScaleFilter(), sc3 = new DataLinearScaleFilter();
	GroupRenderer painter = new GroupRenderer();
  	DataXYLineRenderer p1 = new DataXYLineRenderer(), p2 = new DataXYLineRenderer(), p3 = new DataXYLineRenderer();
  	NormExtentsFilter normsc = new NormExtentsFilter();
  	SNormExtentsFilter snormsc = new SNormExtentsFilter(), snormsc2 = new SNormExtentsFilter(), snormsc3 = new SNormExtentsFilter();
  	GroupExtents grpext = new GroupExtents();
  	GroupSNormExtents grpNext = new GroupSNormExtents();    
	CursorSource cursor = new CursorSource();
	DataLinearScaleFilter cursor_scale = new DataLinearScaleFilter();
	LabelAdapter cursor_label;

	GridRenderer grid = new GridRenderer();
	DataLinearScaleFilter anno_scale = new DataLinearScaleFilter();
	AnnotationRenderer anno = new AnnotationRenderer();
  public void actionPerformed(ActionEvent e)
    {
      String chk = e.getActionCommand();
      if (chk == open.getLabel()) files.setVisible(true);
      if (chk == ext3.getLabel()) grpNext.Open();
      if (chk == ext2.getLabel()) snormsc.Open();
      if (chk == ext.getLabel()) scail.Open();
      /*if (chk == refresh.getLabel()) {
	//painter.setChanged();
	painter.notifyObservers(); 
      }*/
      if (chk == key.getLabel()) {
	System.out.println("Key Toggle Pressed");
	if (painter.GetKeyVisible())
	  painter.SetKeyVisible(false);
	else
	  painter.SetKeyVisible(true);
      }
    }
	
	public void init()
	{
		super.init();
		mainFr = new Frame("TestF");
		
		mainFr.setLayout( new GridLayout(1,1) );

		try { cp = new CanvasPanel( 
			Class.forName( "java.awt.Label" ),
			Class.forName( "java.awt.Label" ),
			// Class.forName( "java.awt.TextField" ),
			Class.forName( "CanvasView" ) ); 
			} catch( Exception e ) { 
				System.out.println( "Exception: "+e.toString() );
		}
		screen = (CanvasView)cp.center;
		lab = new LabelAdapter();
		infile = new ListTodoubleArrays("/home/jpgarcia/JIPC/test.dat",15);
		dtst = new MergedDataSource(infile.col(4),infile.col(15));
		dts  = new MergedDataSource(infile.col(3),infile.col(15));
		dts3 = new MergedDataSource(infile.col(2),infile.col(15));
		infile = null;
		snormsc.SetInput( dts );
		snormsc2.SetInput( dtst);
		snormsc3.SetInput( dts3);
		scail.SetInput( snormsc );   // ultimately should be self? 
		scail.SetMaxSource( dts );
		zero.SetInput( scail );
		// zero.SetZeroLine( false );
		sca2.SetInput( snormsc2);
		sca2.SetMaxSource(dtst);
		grpNext.AddInput(snormsc);
		grpNext.AddInput(snormsc2);
		//grpNext.AddInput(snormsc3);
	 
		grpext.AddInput(scail);
		grpext.AddInput(sca2);
		z2.SetInput(sca2);
		sc2.SetSource(z2);
		sc2.SetDestination( screen.dataView());
		sc2.SetInput(z2);
		sc3.SetInput(snormsc3);
		sc3.SetSource(snormsc3);
		sc3.SetDestination( screen.dataView());
		scale.SetSource( zero );
		scale.SetDestination( screen.dataView() );
		scale.SetInput( zero );
		p1.SetInput( scale);
		p2.SetInput( sc2 );
		p3.SetInput( snormsc3);
		//sca2.CopyExtents(scail);
		//scail.SetExtentChild(sca2);
		p1.SetColor(Color.red);
		p2.SetColor(Color.green);
		p3.SetColor(Color.blue);
		//painter.SetKeyVisible(true);
		painter.AddInput( p1,"Temp C");
		painter.AddInput( p2,"DewPt C");
		//painter.AddInput( p3,"Pressure");
		//painter.SetInput( zero, 3,"");
		screen.SetRenderer(painter);
		lab.SetInput( zero );
		lab.AttachBottomLeft( (Label)cp.bl );
		lab.AttachTopRight( (Label)cp.tr );

// now let's create a mouse cursor 
		screen.SetCursorOutput( cursor ); 
		cursor_scale.SetSource( screen.dataView() );
		cursor_scale.SetDestination( zero );  // reverse it! 
		cursor_scale.SetInput( cursor );     
		cursor_label = new LabelAdapter();
		cursor_label.SetInput( cursor_scale );
		cursor_label.AttachCursor( cp.bm );

		grid.SetHorizontalDivisions( 10 );
		grid.SetVerticalDivisions( 10 );
		//grid.SetInput( painter );
		grid.SetInput( screen.dataView() );
		painter.AddInput(grid, "");
		//screen.AddBackgroundRenderer( grid );

// how about some annotations
		Annotation annie = new Annotation();
		annie.x=2;
		annie.y=3;
		annie.text="hello";
		anno_scale.SetSource( zero );
		anno_scale.SetDestination( screen.dataView() );  
		anno.SetCoordFilter( anno_scale );
		anno.AddAnnotation( annie );
		screen.AddBackgroundRenderer( anno );
// A menu bar
		/*open = new MenuItem("Open...");
		  close = new MenuItem("Close");
		  ext = new MenuItem("Extents");
		  file = new Menu("File");
		  ops = new Menu("Options");
		  mbar = new MenuBar();*/
		file.add(open);
		ops.add(refresh);
		ops.add(ext);
		ops.add(ext2);
		ops.add(ext3);
		ops.add(key);
		//close.setEnabled(false);
		mbar.add(file);
		mbar.add(ops);
		open.addActionListener(this);
		refresh.addActionListener(this);
		ext.addActionListener(this);
		ext2.addActionListener(this);
		ext3.addActionListener(this);
		key.addActionListener(this);
		mainFr.setMenuBar(mbar);
		mainFr.add( cp );
		mainFr.setSize(250,250);
		mainFr.setVisible(true);
		files = new FileDialog(mainFr,"Open",files.LOAD);
	}
                public void destroy(){
		mainFr.dispose();
	}
  
}
		
		
