/**
 *
 * Tue Dec 09 00:00:00 1997 tests/testh.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class testh extends Applet implements ActionListener, ItemListener
{
  final int gcount = 4;
  Frame main = new Frame("JIPC: testh.java");
  Panel left, right, top, bottom;
  Button ky = new Button("Key Toggle"), gs = new Button("SNorm XTs"), 
         gn = new Button("Norm XTs"), ge = new Button("Extents"),
         pr = new Button("Print");
  Checkbox []cb = new Checkbox[gcount];
  Choice ch = new Choice(), zmpch = new Choice();
  Label txt = new Label("Scaled to:", Label.CENTER);
  //Menu ops = new Menu("Options");
  PopupMenu pops = new PopupMenu("[Options]");
  MenuItem groupext = new MenuItem("Group Extents"), 
    gnormext = new MenuItem("Group Norm Extents"),
    gsnormext = new MenuItem("Group SNorm Extents"),
    key = new MenuItem("Key Toggle");
  CanvasPanel cp;
  LabelAdapter lab;
  CanvasView screen;
  LabeledGridRenderer grid = new LabeledGridRenderer();
  MergedDataSource [] mds = new MergedDataSource[gcount];
  DataLinearScaleFilter[] scale = new DataLinearScaleFilter[gcount];
  DataLinearScaleFilter  cursor_scale = new DataLinearScaleFilter();
  GroupRenderer painter = new GroupRenderer();
  DataXYLineRenderer []xy = new DataXYLineRenderer[gcount];
  SpikeFilter [] spk = new SpikeFilter[gcount];
  SNormExtentsFilter []snormext = new SNormExtentsFilter[gcount];
  GroupSNormExtents gsnorm = new GroupSNormExtents();
  NormExtentsFilter []normext = new NormExtentsFilter[gcount];
  GroupNormExtents gnorm = new GroupNormExtents();
  ExtentsFilter [] ext = new ExtentsFilter[gcount];
  GroupExtents gext = new GroupExtents();
  CursorSource cursor = new CursorSource();
  LabelAdapter cursor_label;
  CanvasZoomPan czp = null;

  public void mouseClicked(MouseEvent e)
    {
      //pops.show(screen, e.getX(), e.getY());
      //System.out.println("Mouse Clicked.");
    }
  public void mouseEntered(MouseEvent e)
    {
      //pops.show(screen, e.getX(), e.getY());
      //System.out.println("Mouse Entered.");
    }
  public void mouseExited(MouseEvent e)
    {
      //pops.show(screen, e.getX(), e.getY());
      //System.out.println("Mouse Exited.");
    }
  public void mousePressed(MouseEvent e)
    {
      pops.show(screen, e.getX()-70, e.getY()-15);
      //System.out.println(e.getX() + " x " + e.getY());
      //System.out.println("Mouse Pressed.");
    }
  public void mouseReleased(MouseEvent e)
    {
      //pops.show(screen, e.getX(), e.getY());
      //System.out.println("Mouse Released.");
    }
  public void itemStateChanged(ItemEvent e)
    {
      Object chk = e.getItemSelectable();
      for (int z=0; z<gcount; z++)
	if (chk == (Object)cb[z]){
	  //System.out.println(z + " checked");
	  if (painter.GetVisible(xy[z])){
	    gext.RemoveInput(ext[z]);
	    gnorm.RemoveInput(normext[z]);
	    painter.SetVisible(xy[z],false);
	  }else{
	    gext.AddInput(ext[z]);
	    gnorm.AddInput(normext[z]);
	    painter.SetVisible(xy[z],true);
	  }
	}
      if (chk == (Object)zmpch){
	czp.SetPan(false);
	switch(zmpch.getSelectedIndex()){
	case(0): czp.SetPan(true);
	  break;
	case(1): czp.SetZoomIn(true);
	  break;
	case(2): czp.SetZoomIn(false);
	}
      }
      if (chk == (Object)ch){
	System.out.println("Choice changed");
	for (int z=0; z<gcount; z++)
	  if (ch.getSelectedItem() == painter.GetLabel(xy[z])){
	    grid.SetExtents(snormext[z]);
	    cursor_scale.SetDestination( snormext[z] );
	    lab.SetInput( snormext[z] );
	  }
      }
    }
  public void actionPerformed(ActionEvent e)
    {
      String chk = e.getActionCommand();
      if (chk == ge.getLabel()) gext.Open();
      if (chk == gn.getLabel()) gnorm.Open();
      if (chk == gs.getLabel()) gsnorm.Open();
      if (chk == pr.getLabel()) screen.printAll(screen.getGraphics());
      if (chk == ky.getLabel()) 
	painter.ToggleKeyVisible();
    }
  public void init()
    {
      main.setLayout( new BorderLayout());
      main.setSize(600,600);
      try { 
	cp = new CanvasPanel( 
			     Class.forName( "java.awt.Label" ),
			     Class.forName( "java.awt.Label" ),
			     // Class.forName( "java.awt.TextField" ),
			     Class.forName( "CanvasView" ) ); 
      } catch( Exception e ) { 
	System.out.println( "Exception: "+e.toString() );
      }
      screen = (CanvasView)cp.center;
      lab = new LabelAdapter();
      URLTodoubleArrays input=new URLTodoubleArrays
	("file:///home/jpgarcia/JIPC/test.dat",
	//("/pub/wisc95/sonde/sep/092695/msn_2102.dat",
	 16,13,true);
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==15) z++;
	mds[pl] = new MergedDataSource(input.c(z),input.c(15));
      }
      for (int z=0; z<gcount; z++){
	scale[z] = new DataLinearScaleFilter();
	xy[z] = new DataXYLineRenderer();
	snormext[z] = new SNormExtentsFilter();
	normext[z] = new NormExtentsFilter();
	ext[z] = new ExtentsFilter();
	spk[z] = new SpikeFilter();
	spk[z].SetInput( mds[z] );
	spk[z].SetXVariance( 100 );
	spk[z].SetYVariance( 1000 );
	spk[z].SetYRes( 10 );
	spk[z].SetXRes( 10 );
	ext[z].SetInput( spk[z]);
	gext.AddInput( ext[z] );
	normext[z].SetInput( ext[z] );
	gnorm.AddInput( normext[z] );
	snormext[z].SetInput( normext[z] );
	gsnorm.AddInput( snormext[z] );
	scale[z].SetInput( snormext[z] );
	scale[z].SetSource( snormext[z] );
	scale[z].SetDestination( screen.dataView() );
	xy[z].SetInput( scale[z] );
	xy[z].SetColor( new Color((float)Math.random(),(float)Math.random(),
				  (float)Math.random() ));
      }
      painter.SetFont( new Font("Times", Font.BOLD, 12));
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==15) z++;
	painter.AddInput( xy[pl], 		       
			  input.h(z) + "(" + input.u(z) + ") vs. " + 
			  input.h(15) + "(" + input.u(15) + ")" );      
      }
      for (int z=0; z<gcount; z++)
	cb[z] = new Checkbox(painter.GetLabel(xy[z]), true);
      screen.SetRenderer( painter );
      input = null;

      lab.SetInput( snormext[0] );
      lab.AttachBottomLeft( (Label)cp.bl );
      lab.AttachBottomLeft( (Label)cp.tr );

      screen.SetCursorOutput( cursor ); 
      cursor_scale.SetSource( screen.dataView() );
      cursor_scale.SetDestination( snormext[0] );
      cursor_scale.SetInput( cursor );     
      cursor_label = new LabelAdapter();
      cursor_label.SetInput( cursor_scale );
      cursor_label.AttachCursor( cp.bm );
      cursor_label.round(true);      

      grid.SetHorizontalDivisions( 10 );
      grid.SetVerticalDivisions( 10 );
      grid.SetInput( screen.dataView() );
      grid.SetExtents( snormext[0] );
      grid.SetColor( Color.blue );
      grid.SetZeroColor( Color.red );
      //painter.AddInput( grid, "" );
      screen.AddBackgroundRenderer( grid);
 
      pops.add(key);
      pops.addSeparator();
      pops.add(groupext);
      pops.add(gnormext);
      pops.add(gsnormext);
      ge.addActionListener(this);
      gn.addActionListener(this);
      gs.addActionListener(this);
      ky.addActionListener(this);
      pr.addActionListener(this);
      ch.addItemListener(this);
      zmpch.addItemListener(this);
      right = new Panel( new GridLayout(gcount + 2,1));
      for (int z=0; z<gcount; z++){
	cb[z].addItemListener(this);
	ch.add(painter.GetLabel(xy[z]));
	right.add( cb[z] );
      }

      czp = new CanvasZoomPan();
      czp.SetCanvasView(screen);
      czp.SetGroupExtents(gsnorm);
      screen.AddBackgroundRenderer(czp);
      
      zmpch.add("Pan");
      zmpch.add("Zoom +");
      zmpch.add("Zoom -");
      czp.TogglePan();
      if(czp.GetPan())
        zmpch.select(0);
      else
        if(czp.GetZoomIn())
          zmpch.select(1);
        else
          zmpch.select(2);
      top = new Panel( new GridLayout(1,2));
      bottom = new Panel( new GridLayout(1,2));
      bottom.add(zmpch);
      bottom.add(ky);
      bottom.add(ge);
      //top.validate();
      bottom.add(gn);
      bottom.add(gs);
      bottom.validate();
      left = new Panel( new GridLayout(1,1));
      //screen.addMouseListener(this);
      //CanvasZoomPan czp = new CanvasZoomPan(screen);
      //czp.SetGroup(gsnorm);
      left.add( cp );
      right.add( txt );
      right.add( ch );
      right.validate();
      main.validate();
      //left.add( pops );
      main.add(left, "Center");
      main.add(right, "East");
      //add(top, "North");
      setSize(450,50);
      add(bottom, "South");
      main.setVisible(true);
    }
}
