/**
 *
 * Mon Jan 05 00:00:00 1998 tests/testw.java
 *
 * Copyright (C) 1998 - 2000  Joseph Garcia and Raymond Garcia
 *
 * This file is part of the Java Interactive Plotting Classes Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/
import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;

public class testw extends Applet
{
  final int gcount = 19;
  //Window main = new Window(this);
  Panel left, right, top, bottom;
  DataDialog filedial = new DataDialog();
  Button ky = new Button("Key Toggle"), gs = new Button("SNorm XTs"), 
         gn = new Button("Norm XTs"), ge = new Button("Extents");
  Checkbox []cb = new Checkbox[gcount];
  Choice ch = new Choice(), zmpch = new Choice();
  Label txt = new Label("Scaled to:", Label.CENTER);
  //Menu ops = new Menu("Options");
  MenuBar pops = new MenuBar();
  Menu fil = new Menu("File"), keymen = new Menu("Key"), 
    extmen = new Menu("Extents");
  MenuItem groupext = new MenuItem("Group Extents"), 
    gnormext = new MenuItem("Group Norm Extents"),
    gsnormext = new MenuItem("Group SNorm Extents"),
    load = new MenuItem("Open New Window"),
    load2 = new MenuItem("Open Another File"),
    ex = new MenuItem("Exit JIPC"),
    key = new MenuItem("Key Toggle");
  CanvasPanel cp;
  LabelAdapter lab;
  CanvasView screen;
  LabeledGridRenderer grid = new LabeledGridRenderer();
  MergedDataSource [] mds = new MergedDataSource[gcount];
  DataLinearScaleFilter[] scale = new DataLinearScaleFilter[gcount];
  DataLinearScaleFilter  cursor_scale = new DataLinearScaleFilter();
  GroupRenderer painter = new GroupRenderer();
  DataXYLineRenderer []xy = new DataXYLineRenderer[gcount];
  SpikeFilter [] spk = new SpikeFilter[gcount];
  SNormExtentsFilter []snormext = new SNormExtentsFilter[gcount];
  GroupSNormExtents gsnorm = new GroupSNormExtents();
  NormExtentsFilter []normext = new NormExtentsFilter[gcount];
  GroupNormExtents gnorm = new GroupNormExtents();
  ExtentsFilter [] ext = new ExtentsFilter[gcount];
  GroupExtents gext = new GroupExtents();
  CursorSource cursor = new CursorSource();
  LabelAdapter cursor_label;
  //CanvasZoomPan czp = null;
  URL fromdial = null;
  /* Parameters: */
  String DS, LS, US;
  int dataLine = 1, labelLine = 0;
  boolean units = false;
  public synchronized boolean action(Event e, Object w)
    {
      System.out.println("testw Action");
      try{
      final URL base = new URL("file:/home/jpgarcia/JIPC/test.dat");
     Object chk = e.target;
      for (int z=0; z<gcount; z++)
	if (chk == cb[z])
	  if (painter.GetVisible(xy[z]))
	    painter.SetVisible(xy[z],false);
	  else
            painter.SetVisible(xy[z],true);       
      if (chk == ch){
	System.out.println("Choice changed");
	for (int z=0; z<gcount; z++)
	  if (ch.getSelectedItem() == painter.GetLabel(xy[z])){
	    grid.SetExtents(snormext[z]);
	    cursor_scale.SetDestination( snormext[z] );
	    lab.SetInput( snormext[z] );
	    painter.update(null,null);
	  }
      }
      if (chk == groupext) gext.Open();
      if (chk == gnormext) gnorm.Open();
      if (chk == gsnormext) gsnorm.Open();
      if (chk == key) painter.ToggleKeyVisible();
      if (chk == ge) gext.Open();
      if (chk == gn) gnorm.Open();
      if (chk == gs) gsnorm.Open();
      if (chk == ky) painter.ToggleKeyVisible();
    }catch(MalformedURLException mue){
      System.out.println("Invalid URL");
    }
       return true;
    }
  public void init(){
    try{
      resize(600,600);
    final URL base = new URL("http://lidar.ssec.wisc.edu/");
    //fromdial = base;
    //filedial.open();
    fromdial = new URL(base, getParameter("URL"));
    }catch(MalformedURLException mue){
      System.out.println("Invalid URL");
    }
    // main.setLayout( new BorderLayout());
    //main.setSize(600,600);
    //setTitle("JIPC: testk.class");
    setLayout( new BorderLayout());
    //setSize(600,600);
      try { 
	cp = new CanvasPanel( 
			     Class.forName( "java.awt.Label" ),
			     Class.forName( "java.awt.Label" ),
			     // Class.forName( "java.awt.TextField" ),
			     Class.forName( "CanvasView" ) ); 
      } catch( Exception e ) { 
	System.out.println( "Exception: "+e.toString() );
      }
      screen = (CanvasView)cp.center;
      lab = new LabelAdapter();
      //try{
      DS = getParameter("DATA");
      LS = getParameter("LABEL");
      US = getParameter("UNITS");
      try{
	if (DS != null)
	  dataLine = Integer.parseInt(DS);
	if (LS != null)
	  labelLine = Integer.parseInt(LS);
	if (US != null)
	  units = !(US=="false");
      }catch(NumberFormatException nfe){}
      URLTodoubleArrays 
	input=new URLTodoubleArrays(fromdial,dataLine,labelLine,units);
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==15) z++;
	mds[pl] = new MergedDataSource(input.c(z),input.c(15));
      }
      for (int z=0; z<gcount; z++){
	scale[z] = new DataLinearScaleFilter();
	xy[z] = new DataXYLineRenderer();
	snormext[z] = new SNormExtentsFilter();
	normext[z] = new NormExtentsFilter();
	ext[z] = new ExtentsFilter();
	spk[z] = new SpikeFilter();
	spk[z].SetInput( mds[z] );
	spk[z].SetXVariance( 100 );
	spk[z].SetYVariance( 1000 );
	spk[z].SetYRes( 10 );
	spk[z].SetXRes( 10 );
	ext[z].SetInput( spk[z]);
	//gext.AddInput( ext[z] );
	normext[z].SetInput( ext[z] );
	gnorm.AddInput( normext[z] );
	snormext[z].SetInput( normext[z] );
	gsnorm.AddInput( snormext[z] );
	scale[z].SetInput( snormext[z] );
	scale[z].SetSource( snormext[z] );
	scale[z].SetDestination( screen.dataView() );
	xy[z].SetInput( scale[z] );
	xy[z].SetColor( new Color((float)Math.random(),(float)Math.random(),
				  (float)Math.random() ));
	//threads[z] = new Thread(tgrp, xy[z], "G" + z);
	
      }
      painter.SetFont( new Font("Times", Font.BOLD, 12));
      for (int z=1, pl=0; pl<gcount; pl++, z++){
	if (z==15) z++;
	painter.AddInput( xy[pl], 		       
			  input.h(z) + "(" + input.u(z) + ") vs. " + 
			  input.h(15) + "(" + input.u(15) + ")" );      
      }
      for (int z=0; z<gcount; z++){
	cb[z] = new Checkbox(painter.GetLabel(xy[z]));
	cb[z].setState(true);
      }
      screen.SetRenderer( painter );
      input = null;

      lab.SetInput( snormext[0] );
      lab.AttachBottomLeft( (Label)cp.bl );
      lab.AttachBottomLeft( (Label)cp.tr );

      screen.SetCursorOutput( cursor ); 
      cursor_scale.SetSource( screen.dataView() );
      cursor_scale.SetDestination( snormext[0] );
      cursor_scale.SetInput( cursor );     
      cursor_label = new LabelAdapter();
      cursor_label.SetInput( cursor_scale );
      cursor_label.AttachCursor( cp.bm );
      cursor_label.round(true);      

      grid.SetHorizontalDivisions( 10 );
      grid.SetVerticalDivisions( 10 );
      grid.SetInput( screen.dataView() );
      grid.SetExtents( snormext[0] );
      grid.SetColor( Color.blue );
      grid.SetZeroColor( Color.red );
      //painter.AddInput( grid, "" );
      screen.AddBackgroundRenderer( grid);
 
      fil.add(load);
      fil.add(load2);
      fil.add(ex);
      keymen.add(key);
      //pops.addSeparator();
      //extmen.add(groupext);
      extmen.add(gnormext);
      extmen.add(gsnormext);
      //pops.add(fil);
      pops.add(keymen);
      pops.add(extmen);
      //main.setMenuBar(pops);
      /*ge.addActionListener(this);
      gn.addActionListener(this);
      gs.addActionListener(this);
      ky.addActionListener(this);
      pr.addActionListener(this);
      ch.addItemListener(this);
      zmpch.addItemListener(this);*/
      right = new Panel();
      //setMenuBar(pops);
      right.setLayout(new GridLayout(gcount + 2,1));
      for (int z=0; z<gcount; z++){
	//cb[z].addItemListener(this);
	ch.addItem(painter.GetLabel(xy[z]));
	right.add( cb[z] );
      }

      /*czp = new CanvasZoomPan();
      czp.SetCanvasView(screen);
      czp.SetGroupExtents(gsnorm);
      screen.AddBackgroundRenderer(czp);*/
      
      zmpch.addItem("Pan");
      zmpch.addItem("Zoom +");
      zmpch.addItem("Zoom -");
      /*czp.TogglePan();
      if(czp.GetPan())
        zmpch.select(0);
      else
        if(czp.GetZoomIn())
          zmpch.select(1);
        else
          zmpch.select(2);*/
      //top = new Panel();
      //top.setLayout(new GridLayout(1,2));
      left = new Panel();
      left.setLayout(new GridLayout(1,1));
      bottom = new Panel();
      bottom.setLayout(new GridLayout(1,3));
      //screen.addMouseListener(this);
      //left.getLayout().addLayoutComponent( "",cp );
      left.add( "",cp );
      left.setVisible(true);
      left.validate();
      bottom.add("",ky);
      bottom.add("",gn);
      bottom.add("",gs);
      bottom.validate();
      right.add( "",txt );
      right.add( "",ch );
      right.setVisible(true);
      right.validate();
      //main.validate();
      validate();
      add("Center",left);
      add("East",right);
      //main.setContainerListener(this);
      //main.setWindowListener(this);
      add("South", bottom);
      //add(left);
      validate();
      //setVisible();
      left.setVisible(true);
      right.setVisible(true);
      bottom.setVisible(true);
      //main.addWindowListener(this);
      //main.pack();
      //main.validate();
      //main.setVisible(true);
      show();
      /*}catch(MalformedURLException mue){
	System.out.println("Invalid URL");
      }*/
      //setVisible(true);
      //main.setVisible(true);
    }
  public void destroy(){
    System.exit(0);
    //dispose();
  }
}
